# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Qnamaker::V4_0
  module Models
    #
    # Response schema for CreateKb operation.
    #
    class KnowledgebaseDTO

      include MsRestAzure

      # @return [String] Unique id that identifies a knowledgebase.
      attr_accessor :id

      # @return [String] URL host name at which the knowledgebase is hosted.
      attr_accessor :host_name

      # @return [String] Time stamp at which the knowledgebase was last
      # accessed (UTC).
      attr_accessor :last_accessed_timestamp

      # @return [String] Time stamp at which the knowledgebase was last
      # modified (UTC).
      attr_accessor :last_changed_timestamp

      # @return [String] Time stamp at which the knowledgebase was last
      # published (UTC).
      attr_accessor :last_published_timestamp

      # @return [String] Friendly name of the knowledgebase.
      attr_accessor :name

      # @return [String] User who created / owns the knowledgebase.
      attr_accessor :user_id

      # @return [Array<String>] URL sources from which Q-A were extracted and
      # added to the knowledgebase.
      attr_accessor :urls

      # @return [Array<String>] Custom sources from which Q-A were extracted or
      # explicitly added to the knowledgebase.
      attr_accessor :sources


      #
      # Mapper for KnowledgebaseDTO class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'KnowledgebaseDTO',
          type: {
            name: 'Composite',
            class_name: 'KnowledgebaseDTO',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              host_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hostName',
                type: {
                  name: 'String'
                }
              },
              last_accessed_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastAccessedTimestamp',
                type: {
                  name: 'String'
                }
              },
              last_changed_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastChangedTimestamp',
                type: {
                  name: 'String'
                }
              },
              last_published_timestamp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastPublishedTimestamp',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              user_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userId',
                type: {
                  name: 'String'
                }
              },
              urls: {
                client_side_validation: true,
                required: false,
                serialized_name: 'urls',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sources: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
